// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rcss3d_agent_msgs:msg/Effector.idl
// generated code does not contain a copyright notice

#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__EFFECTOR__STRUCT_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__EFFECTOR__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'hinge_joint_vels'
#include "rcss3d_agent_msgs/msg/detail/hinge_joint_vel__struct.hpp"
// Member 'universal_joint_vels'
#include "rcss3d_agent_msgs/msg/detail/universal_joint_vel__struct.hpp"
// Member 'beams'
#include "rcss3d_agent_msgs/msg/detail/beam__struct.hpp"
// Member 'says'
#include "rcss3d_agent_msgs/msg/detail/say__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rcss3d_agent_msgs__msg__Effector __attribute__((deprecated))
#else
# define DEPRECATED__rcss3d_agent_msgs__msg__Effector __declspec(deprecated)
#endif

namespace rcss3d_agent_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Effector_
{
  using Type = Effector_<ContainerAllocator>;

  explicit Effector_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit Effector_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _hinge_joint_vels_type =
    std::vector<rcss3d_agent_msgs::msg::HingeJointVel_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::HingeJointVel_<ContainerAllocator>>>;
  _hinge_joint_vels_type hinge_joint_vels;
  using _universal_joint_vels_type =
    std::vector<rcss3d_agent_msgs::msg::UniversalJointVel_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::UniversalJointVel_<ContainerAllocator>>>;
  _universal_joint_vels_type universal_joint_vels;
  using _beams_type =
    std::vector<rcss3d_agent_msgs::msg::Beam_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Beam_<ContainerAllocator>>>;
  _beams_type beams;
  using _says_type =
    std::vector<rcss3d_agent_msgs::msg::Say_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Say_<ContainerAllocator>>>;
  _says_type says;

  // setters for named parameter idiom
  Type & set__hinge_joint_vels(
    const std::vector<rcss3d_agent_msgs::msg::HingeJointVel_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::HingeJointVel_<ContainerAllocator>>> & _arg)
  {
    this->hinge_joint_vels = _arg;
    return *this;
  }
  Type & set__universal_joint_vels(
    const std::vector<rcss3d_agent_msgs::msg::UniversalJointVel_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::UniversalJointVel_<ContainerAllocator>>> & _arg)
  {
    this->universal_joint_vels = _arg;
    return *this;
  }
  Type & set__beams(
    const std::vector<rcss3d_agent_msgs::msg::Beam_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Beam_<ContainerAllocator>>> & _arg)
  {
    this->beams = _arg;
    return *this;
  }
  Type & set__says(
    const std::vector<rcss3d_agent_msgs::msg::Say_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Say_<ContainerAllocator>>> & _arg)
  {
    this->says = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rcss3d_agent_msgs::msg::Effector_<ContainerAllocator> *;
  using ConstRawPtr =
    const rcss3d_agent_msgs::msg::Effector_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::Effector_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::Effector_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::Effector_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::Effector_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::Effector_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::Effector_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::Effector_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::Effector_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rcss3d_agent_msgs__msg__Effector
    std::shared_ptr<rcss3d_agent_msgs::msg::Effector_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rcss3d_agent_msgs__msg__Effector
    std::shared_ptr<rcss3d_agent_msgs::msg::Effector_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Effector_ & other) const
  {
    if (this->hinge_joint_vels != other.hinge_joint_vels) {
      return false;
    }
    if (this->universal_joint_vels != other.universal_joint_vels) {
      return false;
    }
    if (this->beams != other.beams) {
      return false;
    }
    if (this->says != other.says) {
      return false;
    }
    return true;
  }
  bool operator!=(const Effector_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Effector_

// alias to use template instance with default allocator
using Effector =
  rcss3d_agent_msgs::msg::Effector_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rcss3d_agent_msgs

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__EFFECTOR__STRUCT_HPP_
