// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/HingeJointPos.idl
// generated code does not contain a copyright notice

#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__HINGE_JOINT_POS__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__HINGE_JOINT_POS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'name'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/HingeJointPos in the package rcss3d_agent_msgs.
/**
  * Information about the angle of the correponding single-axis hinge joint. A zero angle
  * corresponds to straightly aligned bodies. The position angle of each hinge joint
  * perceptor is sent every cycle.
  *
  * Each hinge joint has minimum and maximum limits on its angular position. This varies
  * from hinge to hinge and depends upon the model being used.
 */
typedef struct rcss3d_agent_msgs__msg__HingeJointPos
{
  /// The name of the corresponding hinge joint
  rosidl_runtime_c__String name;
  /// The current position angle in degrees
  float ax;
} rcss3d_agent_msgs__msg__HingeJointPos;

// Struct for a sequence of rcss3d_agent_msgs__msg__HingeJointPos.
typedef struct rcss3d_agent_msgs__msg__HingeJointPos__Sequence
{
  rcss3d_agent_msgs__msg__HingeJointPos * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__HingeJointPos__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__HINGE_JOINT_POS__STRUCT_H_
